package sortingPackage;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

public aspect InnerState {

	public static String innerState;

	public static int lengthConstant=1000;//default value
	
	public static String hashAlg="SHA-1";//default value
	
	//converts byte data to hexadecimal
	private static String INNERSTATEKUconvertToHex(byte[] data) { 
       
		StringBuffer buf = new StringBuffer();
        for (int i = 0; i < data.length; i++) { 
            int halfbyte = (data[i] >>> 4) & 0x0F;
            int two_halfs = 0;
            do { 
                if ((0 <= halfbyte) && (halfbyte <= 9)) 
                    buf.append((char) ('0' + halfbyte));
                else 
                    buf.append((char) ('a' + (halfbyte - 10)));
                halfbyte = data[i] & 0x0F;
            } while(two_halfs++ < 1);
        } 
        return buf.toString();
    } 
	
	//hashes inner state according to the algorithm 
	private void INNERSTATEKUhashAlgorithm() throws UnsupportedEncodingException, NoSuchAlgorithmException
	{
		byte[] theTextToDigestAsBytes = (innerState).getBytes("iso-8859-1");//Can also be "UTF8"
		MessageDigest md = MessageDigest.getInstance(hashAlg);
        md.update( theTextToDigestAsBytes, 0, innerState.length());
        byte[] digest = md.digest();
       
        innerState=INNERSTATEKUconvertToHex(digest);
    }
	
	/*calls hashAlgorithm for hashing
	expected input :none,expected output :void
	exceptions : if hashAlgorithm tries to run an unsupported coding throws UnsupportedEncodingException 
	tries to run an unknown algorithm throws NoSuchAlgorithmException*/
	private void INNERSTATEKUhash()
	{
		try {
			INNERSTATEKUhashAlgorithm();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
	}

	/*handles primitive array type values
	expected input :an object that contains a primitive type array,expected output :void*/
	private void INNERSTATEKUhandleArrays(Object arr)
	{
		Object[] objList=null;
		if(arr instanceof int[])	//choose type
		{
			int[] list=(int[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];	//copy to object list in order to use Arrays.deepToString
			}
		}
		else if(arr instanceof char[])
		{
			char[] list=(char[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		else if(arr instanceof byte[])
		{
			byte[] list=(byte[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
		
		}
		else if(arr instanceof short[])
		{
			short[] list=(short[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		else if(arr instanceof long[])
		{
			long[] list=(long[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		else if(arr instanceof float[])
		{
			float[] list=(float[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		else if(arr instanceof double[])
		{
			double[] list=(double[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		else if(arr instanceof boolean[])
		{
			boolean[] list=(boolean[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
		}
		else if(arr instanceof String[])
		{
			String[] list=(String[])arr;
			objList=new Object[list.length];
			for(int i=0;i<objList.length;i++)
			{
				objList[i]=new Object();
				objList[i]=list[i];//copy to object list in order to use Arrays.deepToString
			}
			
		}
		
		innerState=innerState+(Arrays.deepToString(objList));//add array to string (deeper to its elements)
		
		if(innerState!=null)
		{
			if(innerState.length()>lengthConstant)//if bigger than length constant hash
			{
				INNERSTATEKUhash();
			}
		}
	}
	
	/*checks for array type objects if the list contains hash value,prevents adding to inner state
	expected input :a string containing ',' which may imply it is an output of toString function of an array type collection object,expected output :void*/
	private void INNERSTATEKUhandleObjects(String oldVal)
	{
		String newVal="";
		String temp="";
		String check="";
		
			String[] list=oldVal.split(",");
			for(int k=0;k<list.length;k++)
			{
				if(!list[k].contains("@"))//if not contains java's hash function value 
				{
					newVal=newVal+list[k];
				}
				else//may contain java's hash code value
				{
					temp=list[k];
					temp=temp.trim();//remove space character from the beginning
					
					if(temp.charAt(0)!='@')//first character is not '@'
					{
						int previousIndexOfAt=temp.indexOf('@')-1;
						int nextIndexOfAt=previousIndexOfAt+2;
						
						if(temp.charAt(previousIndexOfAt)!='['&&temp.charAt(previousIndexOfAt)!=' '&&temp.charAt(previousIndexOfAt)!=',')
						{
							while(nextIndexOfAt<temp.length()&&temp.charAt(nextIndexOfAt)!=']'&&temp.charAt(nextIndexOfAt)!=' '&&temp.charAt(nextIndexOfAt)!=',')//loop until the end of the value in the array
							{
								check=check+temp.charAt(nextIndexOfAt);
								nextIndexOfAt++;
							}
							
							if(!check.matches("[a-fA-f0-9][a-fA-f0-9][a-fA-f0-9][a-fA-f0-9][a-fA-f0-9][a-fA-f0-9][a-zA-z0-9][a-fA-f0-9]"))//matches with 8 hexadecimal regexp
							{
								newVal=newVal+list[k];
								check="";
							}
						}
						
					}
					else//first character is '@'
					{
						newVal=newVal+list[k];
					}
					
				}
				
			}
			innerState=innerState+newVal;
	}
	
	
	/*calls handle arrays if value is an array,if value contains '@' checks for hash value and remove if exists,
	else if it contains ',' call handle objects for handling array type objects
	expected input :a single object that contains an input parameter or return value,expected output :void*/
	private void INNERSTATEKUaddition(Object singleParameterOrReturnValue)
	{
		if(singleParameterOrReturnValue.getClass().isArray())//argumentList[i] is an array parameter
		{
			Object arr = new Object();
			arr=singleParameterOrReturnValue;
			INNERSTATEKUhandleArrays(arr);	
		}
		else 
		{
			if(singleParameterOrReturnValue.toString().contains("@"))//argumentList[i] is an object parameter
			{
				String hashCodeOfObject=Integer.toHexString(singleParameterOrReturnValue.hashCode());//hash code of the object
				String oldVal=singleParameterOrReturnValue.toString();
				
				if(singleParameterOrReturnValue.toString().contains(hashCodeOfObject))//contains hash code of the object (java's toString method for objects has run) 
				{	
					innerState=innerState+oldVal.substring(0, oldVal.indexOf("@"));//remove hash value part;
				}
				else
				{
					if(oldVal.contains(","))//if a list type object (array list,hash table,stack,queue etc.) 
					{
						oldVal=singleParameterOrReturnValue.toString();
						INNERSTATEKUhandleObjects(oldVal);
					}
					else
					{
						innerState=innerState+singleParameterOrReturnValue;
					}
				}
				
				
			}
			else// argumentList[i] is a primitive type
			{
				innerState=innerState+singleParameterOrReturnValue;
			}
	
		}
		
	}
	
	/*calls addition function if value is not null,if null adds 'null' to inner state,and hash if needed
	expected input :an object array that contains input parameters,expected output :void*/
	private void INNERSTATEKUaddToInnerState(Object [] argumentList)
	{
		for(int i=0;i<argumentList.length;i++) //for all arguments that passed to a function
		{
			if(argumentList[i]!=null)
			{
				INNERSTATEKUaddition(argumentList[i]);//add to inner state
			}
			else //if null parameter passed
			{
				innerState=innerState+"null";
			}
			
			if(innerState!=null)
			{
				if(innerState.length()>lengthConstant)
				{
					INNERSTATEKUhash();
				}
			}
		}
	}
	
	/*Writes inner state to console screen
	expected input :none,expected output :void*/
	private void INNERSTATEKUwriteInnerState()
	{
		if(innerState != null && innerState.contains("null"))//In the end,after hashed null can be seen at the end of inner state (unknown reason)
		{
			 innerState=innerState.replace("null", "");
		}
		System.out.println(innerState);
	}

	
	//### Point cut declarations
	
	//All function executions except InnerState.aj functions
	pointcut functionExecuted() : execution(* *(..)) && !execution(void main(..))&& !execution(void INNERSTATEKUhandleArrays(..))&& !execution(void INNERSTATEKUhash(..))&& !execution(void INNERSTATEKUhandleObjects(..))&& !execution(String INNERSTATEKUconvertToHex(..))&& !execution(void INNERSTATEKUaddToInnerState(..))&& !execution(void INNERSTATEKUaddition(..))&& !execution(void INNERSTATEKUwriteInnerState(..)); 
	
	//All field settings
	pointcut setField() : set(* *) && !set(String innerState)&& !set(int lengthConstant) && !set(String hashAlg);
	
	//Execution of Main
	pointcut mainExecution() : execution(void main(..));
	
	//All function calls except InnerState.aj functions
	pointcut  functionCall(): execution(* *(..))&& !execution(void main(..))&& !execution(void INNERSTATEKUhandleArrays(..))&& !execution(void INNERSTATEKUhash(..))&& !execution(void INNERSTATEKUhandleObjects(..))&& !execution(String INNERSTATEKUconvertToHex(..))&& !execution(void INNERSTATEKUaddToInnerState(..))&& !execution(void INNERSTATEKUaddition(..))&& !execution(void INNERSTATEKUwriteInnerState(..));
	
	//### End of Point cut declarations
	
	//This pointcut used for capturing return values of functions
	after() returning(Object returnVal):functionCall()
	{
		if(returnVal!=null)
		{
			INNERSTATEKUaddition(returnVal);//Call addition directly because returnVal is already a single value
		}
		else //if null parameter passed
		{
			innerState=innerState+"null";
		}
		
		if(innerState!=null)
		{
			if(innerState.length()>lengthConstant)
			{
				INNERSTATEKUhash();
			}
		}
	}

	//This pointcut used for capturing a field's value whenever it is set 
	after(): setField()
	{
		Object[] args = thisJoinPoint.getArgs();
		INNERSTATEKUaddToInnerState(args);//Add parameters to InnerState
	}
	
	//This pointcut used for adding function's name and function parameters to inner state
	before() : functionExecuted() 
	{ 
		String functionName = thisJoinPoint.getSignature().getName(); //Get function's name
		innerState=innerState+functionName;

		Object[] args = thisJoinPoint.getArgs();
		INNERSTATEKUaddToInnerState(args); //Add function's parameters to inner state
	} 
	
	
	//This pointcut used for final hashing and writing the final inner state.
	after():mainExecution()
	{
		INNERSTATEKUhash();
		INNERSTATEKUwriteInnerState();
	}
	
	//This pointcut used for only getting parameters from main function (for length constant and hash algorithm choice)
	before():mainExecution()
	{
		Object[] args = thisJoinPoint.getArgs();//get arguments of main (args[0] is a string array)
		String[] list=(String[])args[0];
		
		String prefixHash="-INNERSTATEhash ";
		String prefixThreshold="-INNERSTATEthreshold ";
		
		boolean hashAssigned=false,lengthConstantAssigned=false;
		
		for(int i=0;i<list.length;i++)
		{
			if(list[i].contains(prefixHash))
			{
				hashAlg = list[i].replace(prefixHash, "");
				hashAssigned=true;
			}
			else if(list[i].contains(prefixThreshold))
			{
				lengthConstant = Integer.parseInt(list[i].replace(prefixThreshold, ""));
				lengthConstantAssigned=true;
			}
			
			if(hashAssigned&&lengthConstantAssigned)//No need to check others
			{
				break;
			}
		}
		
	}
}